Protect backslash to avoid premature substitution
[osm/vim-emu.git] / utils / ci / check_manual_usage_example.sh
1 #!/bin/bash
2 export DOCKER_HOST="unix:///var/run/docker.sock"
3
4 set -e
5 set -x
6
7 W() {
8 # Wait until a line appears in the screen session.
9 # It starts from the beginning of the log and exits after the first match.
10 local T=${2:-20s}
11 #timeout -k 3s ${T} stdbuf -o0 grep -q -m 1 "^${1}" <(tail -F -n+0 screenlog.0)
12 # (HACK) As Jenkins blocks subshell, we must use an intermediate script
13 local SUBF=$(mktemp)
14 chmod +x ${SUBF}
15 cat > ${SUBF} <<- EOF
16 #!/bin/bash -e
17 while true; do
18 if strings screenlog.0 | grep -m 1 "\${1}"; then
19 exit 0
20 fi
21 sleep 0.5s
22 done
23 EOF
24 local RES=0
25 timeout -k 3s ${T} ${SUBF} "${1}" || RES=$?
26 rm -f ${SUBF}
27 if [ ! "$RES" = "0" ]; then
28 sync
29 echo -e "\n\n\n(Debug) Error while waiting for a pattern to appear in screenlog.0\n\n\n"
30 strings screenlog.0
31 fi
32 return ${RES}
33 }
34
35 Cmd() {
36 # Send a command to the screen session, aka into the containernet prompt
37 screen -S sonemu -X stuff "${1}^M"
38 }
39
40
41 if ! screen --version | grep 'Screen version'; then
42 # Install screen and do an initial cleanup
43 sudo apt-get update -qq -y
44 sudo apt-get install -y screen
45 screen --version | grep 'Screen version'
46 fi
47 if ! timeout --version; then
48 # Install coreutils for the timeout command
49 sudo apt-get update -qq -y
50 sudo apt-get install -y coreutils
51 timeout --version
52 fi
53 # Initial cleanup
54 pkill -f 'SCREEN -L -S sonemu' || true
55 screen -wipe || true
56 rm -f screenlog.0
57
58
59 # Start containernet with a topology
60 screen -L -S sonemu -d -m sudo python src/emuvim/examples/simple_topology.py
61 # Setup screen for immediate flusing
62 screen -S sonemu -X logfile flush 0
63 # Wait for the cli to start
64 W '^*** Starting CLI:' 60s
65 # Print nodes
66 Cmd 'nodes'
67 # Start vnf1
68 son-emu-cli compute start -d datacenter1 -n vnf1 && sleep 1s
69 # Start vnf2
70 son-emu-cli compute start -d datacenter1 -n vnf2 && sleep 1s
71 # List compute nodes
72 son-emu-cli compute list && sleep 1s
73 sync # avoid text overlapping
74 # Gather some infos
75 Cmd 'sh sync'
76 Cmd 'sh echo "... starting various checks"'
77 sync # avoid text overlapping
78 Cmd 'vnf1 ifconfig && sync && echo -e "\\n... checked vnf1"'
79 W "^... checked vnf1"
80 Cmd 'vnf2 ifconfig && sync && echo -e "\\n... checked vnf2"'
81 W "^... checked vnf2"
82 # Try to ping vnfs
83 Cmd 'vnf1 ping -c 2 vnf2 && sync && echo -e "\\n... checked ping"'
84 W "^... checked ping" 20s
85 Cmd 'quit'
86 # Wait for sonemu to end
87 W '*** Done'
88
89 echo -e '\n\n******************* Result ******************\n\n'
90 strings screenlog.0
91 echo -e '\n\n*********************************************\n\n'
92
93
94 # Check the ping result
95 if grep ', 2 received' screenlog.0; then
96 echo 'No problems detected'
97 exit 0
98 else
99 echo 'Ping is broken !'
100 exit 1
101 fi